' ----------------------------------------------------------------
' WTF! demo for Boriel's ZX BASIC Compiler using NIRVANA+
'
' This demo requires a wtile file generated as follows:
'
' wtf.exe wtfdemo.btile
'
' Afterwards, the program can be compiled as follows:
'
' zxb.exe -t -O3 wtfdemo.bas
'
' It also requires NIRVANA+ recompiled with wtiles enabled as follows:
'
' pasmo --equ ENABLE_WIDE_DRAW --equ ENABLE_WIDE_SPRITE --tap nirvana+.asm NIRVANA_WT
'
' Afterwards, use the following loader to load both blocks and execute them:
'
' 10 CLEAR VAL "32767"
' 20 LOAD "NIRVANA_WT"CODE
' 30 LOAD ""CODE
' 40 RANDOMIZE USR VAL "32768"
' ----------------------------------------------------------------
#include "nirvana+.bas"

    DIM lin(0 TO 5) AS BYTE
    DIM col(0 TO 5) AS BYTE
    DIM frame(0 TO 5) AS BYTE
    DIM sprite AS UBYTE

    ' Set wtile address
    NIRVANAwides(@wtiles)

    ' Initialize screen
    INK 0: PAPER 0: BORDER 0: BRIGHT 0: FLASH 0: CLS
    PRINT PAPER 6;AT 0,0;"WTF! WTILES DEMO  \* Einar Saukas"

    ' Initialize wtiles
    RANDOMIZE
    FOR sprite=0 TO 5
        LET lin(sprite) = sprite*28+32
        LET col(sprite) = INT(RND*28)+1
        LET frame(sprite) = INT(RND*8)
    NEXT sprite

    ' Activate NIRVANA ENGINE
    NIRVANAstart()

    DO
        ' Move and animate wtiles
        FOR sprite=0 TO 5
            LET frame(sprite) = frame(sprite)+1
            IF frame(sprite) = 4 THEN
                LET col(sprite) = col(sprite)+1
                IF col(sprite) = 29 THEN
                    LET frame(sprite) = 7
                ELSE
                    LET frame(sprite) = 0
                END IF
            ELSEIF frame(sprite) = 8 THEN
                LET col(sprite) = col(sprite)-1
                IF col(sprite) = 0 THEN
                    LET frame(sprite) = 3
                ELSE
                    LET frame(sprite) = 4
                END IF
            END IF
        NEXT sprite

        ' Draw wtiles automatically using sprites
        NIRVANAhalt()
        FOR sprite=0 TO 5
            NIRVANAspriteT(sprite, frame(sprite), lin(sprite), col(sprite))
        NEXT sprite
    LOOP

wtiles:
    asm
        incbin "wtfdemo.wtile"
    end asm
